from typing import Any

from simudator.core.breakpoint import Breakpoint
from simudator.core.module import Module


class StateBreakpoint(Breakpoint):
    def __init__(self, module: Module, state: str, value: Any) -> None:
        super().__init__()
        self.module = module
        self.state = state
        self.value = value

    def is_break(self):
        return self.module.get_state()[self.state] == self.value

    def __str__(self) -> str:
        return self.module.name + " " + self.state + " == " + str(self.value)
