from qtpy.QtCore import QRunnable


class RunThread(QRunnable):
    """
    This class is used to run the cpu on a seperate thread.
    This allows the user to interact with the GUI will th cpu is running.
    When the cpu halts this thread will emit to it's given signal
    the GUI can then handel what should happend after execution on its own.
    """

    def __init__(self, cpu, signal, run_continuously=True, steps=0):
        super().__init__()
        self.cpu = cpu
        self.signal = signal
        self.run_continuously = run_continuously
        self.steps = steps

    def run(self):
        if self.run_continuously:
            self.cpu.run_continuously()

        else:
            for _ in range(self.steps):
                self.cpu.do_tick()

        self.signal.emit(self.steps)
