from simudator.core.processor import Processor
from simudator.core.signal import Signal
from simudator.processor.mia.modules.ir import IR


def test_ir():
    cpu = Processor()
    t_bus = Signal(cpu)
    f_bus = Signal(cpu)
    op_s = Signal(cpu)
    grx_s = Signal(cpu)
    m_s = Signal(cpu)
    bus_control_s = Signal(cpu)
    bus_id = 1
    default_value = 2
    ir = IR(t_bus, f_bus, op_s, grx_s, m_s, bus_control_s, default_value, bus_id)
    cpu.add_module(ir)

    instruction = 0b0001101100000111
    f_bus.update_value(instruction)
    bus_control_s.update_value((1, 1))
    cpu.do_tick()
    assert t_bus.get_value() == instruction
    assert m_s.get_value() == (instruction >> 8) & 0b11
    assert grx_s.get_value() == (instruction >> 10) & 0b11
    assert op_s.get_value() == (instruction >> 12) & 0b1111
